package com.njcn.bpm.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.njcn.bpm.pojo.param.BpmModelParam;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.engine.repository.Model;

import javax.validation.Valid;

/**
 * Flowable流程模型接口
 *
 * @author yunlongn
 */
public interface IBpmModelService {

    /**
     * 获得流程模型分页
     *
     * @return 流程模型分页
     */
    Page<Model> getModelPage(BpmModelParam.BpmModelQueryParam bpmModelQueryParam);

    /**
     * 创建流程模型
     *
     * @param bpmnXml BPMN XML
     * @return 创建的流程模型的编号
     */
    String createModel(BpmModelParam bpmModelParam, String bpmnXml);

    /**
     * 获得流程模块
     *
     * @param id 编号
     * @return 流程模型
     */
    Model getModel(String id);

    /**
     * 获得流程模型的 BPMN XML
     *
     * @param id 编号
     * @return BPMN XML
     */
    byte[] getModelBpmnXML(String id);

    /**
     * 修改流程模型
     *
     */
    void updateModel(BpmModelParam.BpmModelUpdateParam updateParam);

    /**
     * 将流程模型，部署成一个流程定义
     *
     * @param id 编号
     */
    void deployModel(String id);

    /**
     * 删除模型
     *
     * @param id 编号
     */
    void deleteModel(String id);

    /**
     * 修改模型的状态，实际更新的部署的流程定义的状态
     *
     * @param id    编号
     * @param state 状态
     */
    void updateModelState(String id, Integer state);

    /**
     * 获得流程定义编号对应的 BPMN Model
     *
     * @param processDefinitionId 流程定义编号
     * @return BPMN Model
     */
    BpmnModel getBpmnModelByDefinitionId(String processDefinitionId);

}
